<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
// import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
// import promotionService from '@/service/promotion'
// import { usematerialStore } from '@/stores/material'
import { useMaterialStore } from '@/stores/material'
// import type { Promotion } from '@/types/Promotion'
import type { Material } from '@/types/Material'

const headers = [
  {
    title: 'ID',
    key: 'material_id',
    value: 'material_id'
  },
  {
    title: 'Name',
    key: 'material_name',
    value: 'material_name'
  },
  {
    title: 'QuantityNow',
    key: 'material_qty',
    value: 'material_qty'
  },
  {
    title: 'QTY MIN',
    key: 'material_min',
    value: 'material_min'
  },
  {
    title: 'Unit',
    key: 'material_unit',
    value: 'material_unit'
  },
  {
    title: 'status',
    key: 'material_status',
    value: 'material_status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const loadingStone = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const materialStore = useMaterialStore()
let nextId = 1

let editedIndex = -1
// let lastId = 4
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    materialStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await materialStore.deleteMaterial()
  closeDelete()
}
async function editItem(item: Material) {
  if (!item.material_id) return
  await materialStore.getMaterial(item.material_id)
  dialog.value = true
}
async function deleteItem(item: Material) {
  if (!item.material_id) return
  await materialStore.getMaterial(item.material_id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    materialStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await materialStore.saveMaterial()
  dialog.value = false
  closeDialog()
}
const addpromotion = () => {
  editedIndex += 1
  dialog.value = true
}
onMounted(() => {
  materialStore.getMaterials()
})
</script>

<template>
  <div id="app" class="d-flex justify-center">
    <v-data-table :headers="headers" :items="materialStore.material">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Products</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Material </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Product Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="materialStore.editedMaterial.material_name" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.material_qty" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Qty"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.material_min" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Min"></v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.string="materialStore.editedMaterial.material_unit" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Unit"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.material_price" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Price"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.material_max" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Max"></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="materialStore.getMaterials"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
